<?php
function paginer($url, $param, $total, $current, $adj=3)
{
    /* Dclaration des variables */
    $prev = $current - 1; // numro de la page prcdente
    $next = $current + 1; // numro de la page suivante
    $n2l = $total - 1; // numro de l'avant-dernire page (n2l = next to last)
 
    /* Initialisation : s'il n'y a pas au moins deux pages, l'affichage reste vide */
    $pagination = '';
 
    /* Sinon ... */
    if ($total > 1)
     {
        /* Concatnation du <div> d'ouverture  $pagination */
        $pagination .= "<div class=\"pagination\">\n";
 
        /* ////////// Dbut affichage du bouton [prcdent] ////////// */
         if ($current == 2) // la page courante est la 2, le bouton renvoit donc sur la page 1, remarquez qu'il est inutile de mettre ?p=1
            $pagination .= "<a href=\"{$url}\"><</a>";
     elseif ($current > 2) // la page courante est suprieure  2, le bouton renvoit sur la page dont le numro est immdiatement infrieur
            $pagination .= "<a href=\"{$url}{$param}{$prev}\"><</a>";
       else // dans tous les autres, cas la page est 1 : dsactivation du bouton [prcdent]
            $pagination .= '<span class="inactive"><</span>';
 
         if ($total < 7 + ($adj * 2))
               {
             /* Ajout de la page 1 : on la traite en dehors de la boucle pour n'avoir que index.php au lieu de index.php?p=1 et ainsi viter le duplicate content */
             $pagination .= ($current == 1) ? '<span class="active">1</span>' : "<a href=\"{$url}\">1</a>"; // Oprateur ternaire : (condition) ? 'valeur si vrai' : 'valeur si fausse'
            /* Pour les pages restantes on utilise une boucle for */
                for ($i = 2; $i<=$total; $i++)
                {
                 if ($i == $current) // Le numro de la page courante est mis en vidence (cf fichier CSS)
                 $pagination .= "<span class=\"active\">{$i}</span>";
                 else // Les autres sont affichs normalement
                 $pagination .= "<a href=\"{$url}{$param}{$i}\">{$i}</a>";
                }
               }
 
         else
            {
             if ($current < 2 + ($adj * 2))
                {
                 /* Affichage du numro de page 1 */
                 $pagination .= ($current == 1) ? "<span class=\"active\">1</span>" : "<a href=\"{$url}\">1</a>";
                /* puis des huit autres suivants */
                 for ($i = 2; $i < 4 + ($adj * 2); $i++)
                  {
                    if ($i == $current)
                     $pagination .= "<span class=\"active\">{$i}</span>";
                    else
                    $pagination .= "<a href=\"{$url}{$param}{$i}\">{$i}</a>";
                  }
                    /* ... pour marquer la troncature */
                    $pagination .= ' ... ';
                    /* et enfin les deux derniers numros */
                    $pagination .= "<a href=\"{$url}{$param}{$n2l}\">{$n2l}</a>";
                    $pagination .= "<a href=\"{$url}{$param}{$total}\">{$total}</a>";
                }

                   elseif ( (($adj * 2) + 1 < $current) && ($current < $total - ($adj * 2)) )
                        {
                         /* Affichage des numros 1 et 2 */
                         $pagination .= "<a href=\"{$url}\">1</a>";
                         $pagination .= "<a href=\"{$url}{$param}2\">2</a>";
                         $pagination .= ' ... ';
                          /* les septs du milieu : les trois prcdents la page courante, la page courante, puis les trois lui succdant */
                          for ($i = $current - $adj; $i <= $current + $adj; $i++)
                           {
                            if ($i == $current)
                             $pagination .= "<span class=\"active\">{$i}</span>";
                            else
                             $pagination .= "<a href=\"{$url}{$param}{$i}\">{$i}</a>";
                           }
                             $pagination .= ' ... ';
                            /* et les deux derniers numros */
                             $pagination .= "<a href=\"{$url}{$param}{$n2l}\">{$n2l}</a>";
                             $pagination .= "<a href=\"{$url}{$param}{$total}\">{$total}</a>";
                        }
                          else
                             {
                              /* Affichage des numros 1 et 2 */
                              $pagination .= "<a href=\"{$url}\">1</a>";
                              $pagination .= "<a href=\"{$url}{$param}2\">2</a>";
                              $pagination .= ' ... ';
                              /* puis des neufs dernires */
                              for ($i = $total - (2 + ($adj * 2)); $i <= $total; $i++)
                                  {
                                   if ($i == $current)
                                    $pagination .= "<span class=\"active\">{$i}</span>";
                                   else
                                    $pagination .= "<a href=\"{$url}{$param}{$i}\">{$i}</a>";
                                  }
                            }
            }
                if ($current == $total)
                   $pagination .= "<span class=\"inactive\">></span>\n";
              else
                   $pagination .= "<a href=\"{$url}{$param}{$next}\">></a>\n";
                   $pagination .= "</div>\n";
     }
      /* Fin de la fonction, renvoi de $pagination au programme */
      return ($pagination);
}
?>

